var/list/base64=list(
	"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z",
	"a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z",
	"0","1","2","3","4","5","6","7","8","9","+","/","=")

proc
	b64_encode(string)
		for(var/i=0;i<length(string);i+=3)									// Separate into three digit blocks.
			var/block=copytext(string,i+1,i+4)
			var/list/binary_strings_8=new
			var/binary_text

			for(var/j=1;j<=length(block);j++)
				binary_strings_8+=dec2bin(text2ascii(block,j))


			for(var/b_string_8 in binary_strings_8)
				binary_text+=b_string_8

			while(length(binary_text)<24)										// Make sure the buffer is full.
				binary_text+="0"

			for(var/j=0;j<length(binary_text);j+=6)
				.+=base64[bin2dec(text2num(copytext(binary_text,j+1,j+7)))+1]

			if(binary_strings_8.len<3)											// Block didn't have three digits.
				.="[copytext(.,1,length(.)-(2-binary_strings_8.len))]"				// Remove erroneous digits.
				while(length(.)%4)													// Add padding.
					.+="="

	b64_decode(string)
		for(var/i=0;i<length(string);i+=4)
			var/block=copytext(string,i+1,i+5)
			var/binary_text

			for(var/j=1;j<=length(block);j++)
				binary_text+=copytext(dec2bin(base64.Find(copytext(block,j,j+1))-1),3)

			for(var/j=0;j<length(binary_text);j+=8)
				.+=ascii2text(bin2dec(copytext(binary_text,j+1,j+9)))

	bin2dec(t)
		t=text2num(t)
		for(var/i=1;t;i+=i)
			if(t%2>0)
				.+=i
			t=round(t/10)
	dec2bin(n)
		for(var/i=128;i>=1;i/=2)
			if(n/i>=1)
				.+="1"
				n-=i
			else .+="0"